/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	iic_eeprom.c
//	Version		1.00
//	MCU		R8C/2A_2B
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/05/30	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	dipSW̒lIICΉEEPROMɏ݁AǍ݂sʂLCDɕ\܂B
//	f[^EEPROMɏ݌Ad𗎂ƂĂf[^Ǎ߂܂B
//	xAf[^EEPROMǍނƃf[^폜܂B
//	SW2: SW3:Ǎ
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2008

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* CN[ht@C錾 */

#include "R8C_2A_2B.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^錾 */

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ϐ錾 */

unsigned int x, y;

///////////////////////////////////////////////////////////////////////////////////////////////////
/* }N錾 */

#define ROM_PORT	P0

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ֐̃vg^Cv錾 */

void init_IO ( void );
void set_CLK ( void );
void wait ( unsigned long msec );
void set_si ( void );
void main ( void );
unsigned int char_select (unsigned int c );
unsigned int dip_select (void);

void Clear_LCD ( void );
void Wait_LCD ( const unsigned long Interval );
void Print_LCD ( const char *String );
void Init_LCD ( void );
void Write_LCD (const unsigned char RS_Mode ,const unsigned char Data);
void Locate_LCD ( const unsigned char X, const unsigned char Y );

void Init_IIC ( void );
void byte_write ( unsigned int addr, unsigned char data );
void iic_write ( unsigned char data );
unsigned char byte_read ( unsigned int addr );

///////////////////////////////////////////////////////////////////////////////////////////////////
/* I/OCvbg֐ */

void init_IO ( void )
{
	PRCR = 0x0f;		// veNgWX^
	PD0 = 0x0f;		// P0_3~7dip_sw
	PD1 = 0x03;		// P1_0P1_1LEDo
	PD3 = 0x00;		// P3_5/SCL,P3_4/SDAƂĎgp
	PD5 = 0xff;		// LCD_04~07
	PD6 = 0x03;		// LCD_E,LCD_RS
	PD8 = 0xff;		// P8_0P8_1LEDo
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* NbNZbg */

void set_CLK ( void )
{
/* ONbN20MHz */
	CM1 = 0x08;
	CM0 = 0x14; 
	OCD = 0x00; 
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* VAC^tF[XZbg */
void set_si ( void )
{
	PMR = 0x90;	// UART1AIICI
	U1C1 = 0x05;	// MAM
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* dip_SW */

unsigned int dip_select ( void )
{	
	unsigned int dip;
	unsigned int cun;
	
	dip = 0xff & P0;
	dip = dip >> 4;
	cun = 0;
	
	if((0x01 == (dip & 0x01))){
		cun = cun + 1;
	}
	if((0x02 == (dip & 0x02))){
		cun = cun + 1;
	}
	if((0x04 == (dip & 0x04))){
		cun = cun + 1;	
	}
	if((0x08 == (dip & 0x08))){
		cun = cun + 1;
	}
	return cun;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCg */
void wait ( unsigned long msec )
{
	unsigned long i;

	for(i=0; i<1000*msec; i++);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD */
void Init_LCD ( void )
{
	P5 = 0x00;
	P6 = 0x00;
	
	Wait_LCD ( 20 );
	
	P6 = P6 & ~0x02;		// RS Low Set
	
	/* LCD1 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM1
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	Wait_LCD ( 5 );
	
	/* LCD2 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM2
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* LCD3 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM3
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* LCD4 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x02;	// MM4
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* t@NVZbgFSrbgoXAQsAT~Vhbg */
	Write_LCD ( 0 , 0x28 );
	
	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( 0 , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( 0 , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( 0 , 0x0d );

	/* \NA */
	Clear_LCD ();
	
	Wait_LCD ( 5 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == 0 )
	{
		P6 = P6 & ~0x02;	// RS Low Set
	}
	else if ( RS_Mode == 1 )
	{
		P6 = P6 | 0x02;		// RS High Set
	}
	
	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set
	
	P5 = ( P5 & 0xf0 ) | (( Data >> 4 ) & 0x0f );	// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (  Data & 0x0f );		// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
}
	
///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD J[\ړ */
	
void Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;
	
	Write_LCD( 0 , i );
	Wait_LCD ( 1 );
	
	/* J[\ۑ */
	x = X;
	y = Y;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD NA\ */
	
void Clear_LCD ( void )
{
	P6 = P6 & ~0x02;	// RS Low Set
	Write_LCD ( 0 , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCgLCD */

void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Print_LCD ( const char *String )
{
	unsigned char i, j;
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( 1, String[ i ] );
			Wait_LCD ( 1 );
			
		/* J[\ړ */
			if ( x ==  16 - 1 )
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			x = 0;
			y = ( y == 0 ? 1 : 0 );
			Locate_LCD ( x, y );
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ZNg */
unsigned int char_select ( unsigned int c )
{
	unsigned int out;
	switch (c)
	{
	case 0:
	out = 0x41;	// "A"
	break;
		
	case 1:
	out = 0x42;	// "B"
	break;
		
	case 2:
	out = 0x43;	// "C"
	break;
		
	case 3:
	out = 0x44;	// "D"
	break;
		
	case 4:
	out = 0x45;	// "E"
	break;
	}
	
	return out;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* IIC_ */

void Init_IIC ( void )
{
	/* hhbp|[g */
	MSTCR = 0x08;			//IICoXgp
	ICCR1 = ICCR1 | 0x01;		//]NbNf1/40ɑI
	ICCR1 = ICCR1 | 0x80;		//]\Ԃ
	
	/* rW[`FbN */
	while ( ( ICCR2 & 0x80 ) != 0 );
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* IIC_ */

void byte_write ( unsigned int addr, unsigned char data )
{
	unsigned char code;
	unsigned char str_c, sto_c;
	
	ICCR1 = 0x80;					// 10000000 oXC^[tF[X2Cl[u
	while( ( ICCR2 & 0x80 ) != 0 ){}		// oXrW[tO
							// oXJ܂ő҂
	ICCR1 = ICCR1 | 0x30;				// }X^M[hɐݒ
	
	str_c = (( ICCR2 | 0x80 ) &~0x40 );		// MOV߂Ő錾
	asm(" MOV.B $$[FB],00B9H ",str_c);		// X^[gRfBV BBSY=1,SCP=0
	
/*	iic_write ( 0xa0 );*/				// foCXAhXAM
	iic_write ( 0xa0 + ( ( addr & 0x0700 ) >> 7 ) );// foCXAhXAM
/*	iic_write ( ( addr & 0xff00 ) >> 8 );*/		// ݃AhX
	iic_write ( ( addr & 0x00ff ) );		// ݃AhX
	iic_write ( data );				// ݃f[^
	
	sto_c = ICCR2 & ~0xc2;				// MOV߂Ő錾
	asm(" MOV.B $$[FB],00B9H ",sto_c);		// XgbvRfBV BBSY=0,SCP=0
	
	wait ( 40 );					// ݑ҂
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* IIC_ */

void iic_write ( unsigned char data )	//unsigned char
{
	unsigned char sto_c;
	
	while( (ICSR & 0x80 ) == 0 ){			// TDRE=1 Mf[^GveB܂ő҂
	}
	ICDRT = data;					// f[^
	while( (ICSR & 0x40 ) == 0 ){			// TEND=1 M܂ő҂ 
	}
	if( ( ICIER & 0x02 ) != 0 ){			// ACKAĂȂ
		sto_c = ICCR2 & ~0xc2;			// MOV߂Ő錾
		asm(" MOV.B $$[FB],00B9H ",sto_c);	// XgbvRfBV BBSY=0,SCP=0
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* IIC_Ǎ */

unsigned char byte_read ( unsigned int addr )
{
	unsigned char code;
	unsigned char str_c, sto_c;

	ICCR1 = 0x80;		// 10000000 oXC^[tF[XQCl[u
	while( ( ICCR2 & 0x80 ) != 0 ){			// oXrW[tO
	}						// oXJ܂ő҂
	ICCR1 = ICCR1 | 0x30;				// }X^M[hɐݒ
	
	str_c = (( ICCR2 | 0x80 ) &~0x40 );		// MOV߂Ő錾
	asm(" MOV.B $$[FB],00B9H ",str_c);		// X^[gRfBV BBSY=1,SCP=0

/*	iic_write ( 0xa0 );*/				// foCXAhXAM
	iic_write ( 0xa0 + ( ( addr & 0x0700 ) >> 7 ) );// foCXAhXAM
/*	iic_write ( ( addr & 0xff00 ) >> 8 );*/		// ݃AhX
	iic_write ( ( addr & 0x00ff ) );		// ݃AhX
	ICCR2 = ( ICCR2 | 0x80 ) & ~0x40;		// X^[gRfBV BBSY=1,SCP=0

	iic_write ( 0xa1 );				// foCXAhXAMA݃AhX
	ICCR1 = ICCR1 & ~0x10;				// TRS=0
	ICIER = ICIER & ~0x02;				// MtONA
	ICIER = ICIER | 0x01;				// ACKB=1iANmbWMj
	code = ICDRR;					// _~[M
	while( ( ICSR & 0x20 ) == 0 ){			// RDRF MI܂ő҂
	}
	code = ICDRR;					// f[^M 
	while( (ICSR & 0x20 ) == 0 ){			// MI܂ő҂
	}
	sto_c = ICCR2 & ~0xc2;				// MOV߂Ő錾
	asm(" MOV.B $$[FB],00B9H ",sto_c);		// XgbvRfBV BBSY=0,SCP=0

	return( code );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* C */

void main ()
{
	unsigned char Title[] = "IIC HN58X2416TI Sample program";
	unsigned char input_m[] = "   Ͻ";
	unsigned char output_m[] = "   Ͻ";
	unsigned char output_no_m[] = "  Ͼ!";
	unsigned char output_e_m[] = "ް ޮ Ͻ";

	unsigned short Charactor;
	unsigned short lcdC;

	init_IO ();	// I/OCvbg
	set_CLK ();	// NbNZbg
	set_si ();	// VAC^[tF[X̏ݒ

	init_IO ();	// I/OCvbg
	Init_LCD ();	// LCD	
	Init_IIC ();	// IIC

	Print_LCD( Title );
	wait (500);
	Clear_LCD ();	// LCDNA\

	while(1)
	{
		/*  */
		if((P3 & 0x40) == 0)
		{
		byte_write ( 1, char_select (dip_select ()) );
			P1 = 0x01;
			Locate_LCD ( 0, 1 );
			Write_LCD (1,char_select (dip_select ()));
			Print_LCD ( input_m );
			wait (300);
			Clear_LCD ();
		}

		Locate_LCD ( 0, 0 );

		/* Ǎ */
		if((P3 & 0x04) == 0)
		{
		lcdC = byte_read ( 1 );
			if (( lcdC >= 0x20 && lcdC <= 0x7f ) ||	( lcdC >= 0xa1 && lcdC <= 0xfd ))
			{
				Write_LCD (1,lcdC);
				Print_LCD ( output_m );
				byte_write ( 1,0xff );
				
				Locate_LCD ( 0, 1 );
				Print_LCD ( output_e_m );
				Locate_LCD ( 0, 0 );
				wait (400);
			}
			else if(lcdC == 0xff)
			{
				Print_LCD ( output_no_m );
				wait (300);
			}
			Clear_LCD ();
			P1 = 0x02;
			wait (50);
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
